#include <fstream>
#include <iostream>

using namespace std;
const int nmax = 2e5;

int v[nmax + 5];

int char_to_int(char ch)
{
    if (ch == 'o')
        return 1;
    if (ch == '-')
        return 0;
    if (ch == 'x')
        return -1;
    return 0;
}

int main(int argc, char *argv[])
{
    const string FILENAME("trip");
    ifstream f(FILENAME + ".in");
    ofstream g(FILENAME + ".out");

    int n;
    char c;
    f >> n;
    for (int i = 1; i <= n; i++)
    {
        f >> c;
        v[i] = char_to_int(c);
    }

    int q;
    f >> q;
    for (int i = 1; i <= q; i++)
    {
        int type;
        f >> type;
        if (type == 1)
        {
            char c;
            int pos, val;
            f >> pos >> c;

            if (c == 'x')
                val = -1;
            else if (c == 'o')
                val = 1;
            else
                val = 0;

            v[pos] = val;
        }
        else
        {
            int l1, r1, l2, r2, k;
            f >> l1 >> r1 >> l2 >> r2 >> k;
            bool found = false;
            for (int a = l1; a <= r1; a++)
            {
                if (found)
                    break;
                for (int b = l2; b <= r2; b++)
                {
                    if (found)
                        break;
                    int s = 0;
                    for (int j = a; j <= b; j++)
                        s += v[j];
                    if (s == k)
                    {
                        g << "1\n";
                        found = true;
                    }
                }
            }
            if (!found)
                g << "0\n";
        }
    }
    return 0;
}